/**
 *  Copyright © 2026, Luis Andrés Lange <https://javacomm.net>
 *
 *  This Source Code Form is subject to the terms of the Mozilla Public
 *  License, v. 2.0. If a copy of the MPL was not distributed with this
 *  file, You can obtain one at http://mozilla.org/MPL/2.0/.
 *
 *  ----------------------------------------------------------------------------
 *
 *  Exhibit B - "Incompatible With Secondary Licenses" Notice
 *
 *  This Source Code Form is "Incompatible With Secondary Licenses",
 *  as defined by the Mozilla Public License, v. 2.0.
 *
 *  In short:
 *  - This file may be used, modified, and distributed under MPL 2.0 only.
 *  - It may NOT be relicensed under GPL, LGPL, AGPL, or any other Secondary License.
 *
 *  Rationale:
 *  - Ensures that the code remains MPL-2.0.
 *  - Avoids legal conflicts with GPL-licensed libraries (e.g., VideoLAN).
 *  - Maximizes usability for commercial and security-critical applications.
 *
 */
package net.javacomm.protocol;

import com.google.gson.JsonArray;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonSerializationContext;
import com.google.gson.JsonSerializer;
import java.lang.reflect.Type;



public class TopicMemberSerializer implements JsonSerializer<TOPICMEMBER> {

  @Override
  public JsonElement serialize(TOPICMEMBER topicmember, Type type, JsonSerializationContext context) {
    JsonObject jsonObject = new JsonObject();

    JsonObject dataset = new JsonObject();
    dataset.add(TOPICMEMBER.PSEUDOID, context.serialize(topicmember.getPseudoid()));
    dataset.add(TOPICMEMBER.ROOM, context.serialize(topicmember.getRoom()));
    dataset.add(TOPICMEMBER.ROOMTYPE, context.serialize(topicmember.getRoomtype()));
    JsonArray topicmemberArray = new JsonArray();
    if (topicmember.getChatUser() != null) {
      for (ChatUser chatuser : topicmember.getChatUser()) {
        chatuser.getNickname();
        JsonObject chatuserObject = new JsonObject();
        topicmemberArray.add(chatuserObject);
        chatuserObject.add(ChatUser.NICKNAME, context.serialize(chatuser.getNickname()));
        // Farben und Pseudoid werden nicht benötigt
//        chatuserObject.add(ChatUser.FOREGROUND_COLOR, context.serialize(chatuser.getForegroundColor()));
//        chatuserObject.add(ChatUser.BACKGROUND_COLOR, context.serialize(chatuser.getBackgroundColor()));
//        chatuserObject.add(ChatUser.PSEUDOID, context.serialize(chatuser.getPseudoid()));
      }
      dataset.add(TOPICMEMBER.TOPICMEMBER, context.serialize(topicmemberArray));
    }

    jsonObject.add(Protocol.HEADER, context.serialize(topicmember.getHeader()));
    jsonObject.add("COMMAND", context.serialize(topicmember.getCommand()));
    jsonObject.add(Protocol.DATASET, context.serialize(dataset));

    return jsonObject;
  }

}
